// MainFrame.cpp : implementation file
//

#include "stdafx.h"
#include "PIXIE_III_WB.h"
#include "MainFrame.h"
#ifdef CAD_TEST
	#include "vpi_user.h"
#endif

// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

CMainFrame::CMainFrame()
{

}

CMainFrame::~CMainFrame()
{
}


BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
END_MESSAGE_MAP()


// CMainFrame message handlers


BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	#ifdef CAD_TEST
		vpi_printf("PreCreateWindow starts ...\n");
	#else
		TRACE("PreCreateWindow starts ...\n");
	#endif
	if(!CFrameWnd::PreCreateWindow(cs))
	{
		#ifdef CAD_TEST
			vpi_printf("CFrameWnd::PreCreateWindow fails !!!\n");
		#else
			TRACE("CFrameWnd::PreCreateWindow fails !!!\n");
		#endif
		return FALSE;
	}
	cs.style = WS_OVERLAPPED | WS_CAPTION | FWS_ADDTOTITLE | WS_THICKFRAME | WS_SYSMENU;
	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.lpszClass = AfxRegisterWndClass(0);
	#ifdef CAD_TEST
		vpi_printf("PreCreateWindow\tLast error: %d\n", GetLastError());
		vpi_printf("PreCreateWindow finishes !\n\n");
	#else
		TRACE("PreCreateWindow\tLast error: %d\n", GetLastError());
		TRACE("PreCreateWindow finishes !\n\n");
	#endif
	return TRUE;
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	//DebugBreak();
	#ifdef CAD_TEST
		vpi_printf("OnCreate starts ...\n");
	#else
		TRACE("OnCreate starts ...\n");
	#endif
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	CCreateContext ccx;
	ccx.m_pNewViewClass = RUNTIME_CLASS(CMainView);
	m_pMainView = DYNAMIC_DOWNCAST(CMainView, this->CreateView(&ccx));
	if(!m_pMainView)
	{
		#ifdef CAD_TEST
			vpi_printf("Creation of view failed !!!\n");
		#else
			TRACE("Creation of view failed !!!\n");
		#endif
	}
	RecalcLayout();
	#ifdef CAD_TEST
		vpi_printf("OnCreate RecalcLayout\tLast error: %d\n", GetLastError());
	#else
		TRACE("OnCreate RecalcLayout\tLast error: %d\n", GetLastError());
	#endif
	m_pMainView->ShowWindow(SW_SHOW);
	#ifdef CAD_TEST
		vpi_printf("OnCreate ShowWindow\tLast error: %d\n", GetLastError());
	#else
		TRACE("OnCreate ShowWindow\tLast error: %d\n", GetLastError());
	#endif
	m_pMainView->OnInitialUpdate();
	#ifdef CAD_TEST
		vpi_printf("OnCreate OnInitialUpdate\tLast error: %d\n", GetLastError());
	#else
		TRACE("OnCreate OnInitialUpdate\tLast error: %d\n", GetLastError());
	#endif
	SetActiveView(m_pMainView);
	#ifdef CAD_TEST
		vpi_printf("OnCreate SetActiveView\tLast error: %d\n", GetLastError());
	#else
		TRACE("OnCreate SetActiveView\tLast error: %d\n", GetLastError());
	#endif
	m_pMainView->ResizeParentToFit(FALSE);
	#ifdef CAD_TEST
		vpi_printf("OnCreate ResizeParentToFit\tLast error: %d\n", GetLastError());
		vpi_printf("OnCreate finishes !\n\n");
	#else
		TRACE("OnCreate ResizeParentToFit\tLast error: %d\n", GetLastError());
		TRACE("OnCreate finishes !\n\n");
	#endif
	return 0;
}


BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	if(m_pMainView->OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}


void CMainFrame::OnSetFocus(CWnd* /*pOldWnd*/)
{
	m_pMainView->SetFocus();
}
